/***************************************************************************/
/* Program przykladowy pokazujacy sposob wykorzystania driver'a modulu     */
/* LC-030-1612 firmy AMBEX.                                                */
/***************************************************************************/
/* W katalogu zawierajacym standardowe naglowki C musi sie znajdowac plik  */
/* AMBEX-LC.H.                                                             */
/***************************************************************************/
/* Program musi byc kompilowany w modelu "large" lub "compact" ze wzgledu  */
/* na to, ze w trakcie obslugi przerwan driver przelacza stos (dla         */
/* procedury mod_interrupt_service) - patrz dokumentacja driver'a.         */
/* Z tego tez powodu wskazana jest kompilacja z wylaczonym badaniem stosu  */
/* (dla Turbo C Borlanda jest to opcja kompilacji -N-).                    */
/***************************************************************************/

#include <ambex-lc.h>		/* struktury danych i definicje stalych do */
				/* komunikacji z driver'em                 */
#include <conio.h>		/* funkcja getch                           */
#include <dos.h>		/* funkcja int86                           */
#include <io.h>			/* dla funkcji driverinstalled             */
#include <stdio.h>		/* wyswietlanie                            */
#include <stdlib.h>		/* funkcja exit                            */

/******************** deklaracje procedur **********************************/
void	askdriver(void);
void	asynchrointerr(void);
void	asynchronointerr(void);
void	blocktransmission(void);
void	checkdrivers(void);
void	displaybuf(int *buf, int c, int s);
void	displayconfiguration(void);
void	drivererror(char status, char err_stat);
int	driverinstalled(char *name);
void	failblocktransmission(void);
void	installbreak(void);
void	interruptedafter(void);
void	interruptedbefore(void);
void	mod_interrupt_service(void);
void	pressanykey(void);
void	quit(void);
void	reverse_data(int huge *buf, long len, int chn1, int chn2, int per2);
void	singletransmission(void);
void	transmission(unsigned char start, int asynchro, int interr);
int	transmit_data(int huge *buf, long buflen, long first, long samples,
		  int chn1, int chn2, int per2);

/******************** definicje stalych ************************************/
#define	TRUE		1
#define	FALSE		0
#define	SAMPLES		15			/* liczba probek           */
#define	CHANNELS	8			/* liczba kanalow          */
#define	BUFLEN		(CHANNELS * SAMPLES)	/* dlugosc bufora          */

/******************** deklaracje zmiennych *********************************/
int	LCinterrupt = LC030_16;	/* numer przerwania driver'a               */
				/* rekordy opisu poszczegolnych zlecen     */
struct	lc0_init		s_init        = {MODULE_INIT};
struct	lc0_total		s_total       = {GET_TOTAL_CONFIGURATION};
struct	lc0_module		s_module      = {GET_MODULE_CONFIGURATION};
struct	lc0_info		s_info        = {GET_INFO};
struct	lc0_wait		s_wait        = {WAIT_FOR_END};
struct	lc0_break		s_break       = {BREAK};
struct	lc0_transmit		s_data_trans  = {DATA_TRANSMIT};
struct	lc0_analog_in		s_analog_in   = {ANALOG_INPUT};
struct	lc0_leave		s_leave       = {LEAVE_DRIVER};
struct	lc0_interrupt		s_interr      = {INTERRUPT_SERVICE};
union	REGS	r;		/* parametr dla funkcji int86              */
int	sstat;			/* slowo komunikacyjne dla INTERRUPT_SERVICE*/
int	interruptflag;		/* flaga ustawiana przez procedure obslugi */
				/* przerwania mod_interrupt_service        */
				/* ------- teksty bledow                   */
char	*DriverErrors[] =
    {
						/* LC0_UNKN_FUNC	-1 */
"LC0_UNKN_FUNC: Nieznany kod funkcji",
						/* LC0_NO_MODULE	-2 */
"LC0_NO_MODULE: Bledny numer modulu",
						/* LC0_BAD_DEV_TYP	-3 */
"LC0_BAD_DEV_TYP: Brak urzadzen danego typu",
						/* LC0_NONEX_DEV	-4 */
"LC0_NONEX_DEV: Bledny numer urzadzenia",
						/* LC0_BAD_FREQ		-5 */
"LC0_BAD_FREQ: Bledny okres",
						/* LC0_BAD_RANGE	-6 */
"LC0_BAD_RANGE: Bledny zakres napiec",
						/* LC0_NO_OPER		-7 */
"LC0_NO_OPER: Brak operacji w toku",
						/* LC0_BAD_MARGIN	-8 */
"LC0_BAD_MARGIN: Bledna dlugosc marginesu poczatkowego",
						/* LC0_BAD_BUF_ADR	-9 */
"LC0_BAD_BUF_ADR: Bledny adres bufora",
						/* LC0_BAD_BUF_LEN     -10 */
"LC0_BAD_BUF_LEN: Bledna dlugosc bufora",
						/* LC0_DEV_BUSY	       -11 */
"LC0_DEV_BUSY: Urzadzenie zajete",
						/* LC0_BAD_PER	       -12 */
"LC0_BAD_PER: Za krotki okres probkowania",
						/* LC0_BAD_CHAN_N      -13 */
"LC0_BAD_CHAN_N: Bledna liczba kanalow",
						/* LC0_BAD_CHAN	       -14 */
"LC0_BAD_CHAN: Bledny numer kanalu",
						/* LC0_BROKEN 	       -15 */
"LC0_BROKEN: Przetwarzanie przerwane funkcja BREAK",
						/* LC0_INTR_NOT_INST   -16 */
"LC0_INTR_INST: Procedura obslugi przerwania nie jest zainstalowana",
						/* LC0_ILL_START_CODE  -17 */
"LC0_ILL_START_CODE: Nielegalny sposob startu",
						/* LC0_ILL_STOP_CODE   -18 */
"LC0_ILL_STOP_CODE: Nielegalny sposob stopu",
						/* LC0_BAD_PROC	       -19 */
"LC0_BAD_PROC: Bledny adres procedury obslugi przerwania",
						/* LC0_TOO_LONG_MARG   -20 */
"LC0_TOO_LONG_MARG: Za dlugi margines poczatkowy",
						/* LC0_ILL_START       -21 */
"LC0_ILL_START: Bledne parametry warunku startu",
						/* LC0_ILL_STOP	       -22 */
"LC0_ILL_STOP: Bledne parametry warunku stopu",
						/* LC0_BAD_MNUM	       -23 */
"LC0_BAD_MNUM: Bledny numer pierwszej probki",
						/* LC0_NOT_SUPPORTED   -24 */
"LC0_NOT_SUPPORTED: Funkcja nie jest realizowana",
						/* LC0_BAD_CTC_MODE    -25 */
"LC0_BAD_CTC_MODE: Bledny tryb pracy CTC",
						/* LC0_NO_PARAMS       -26 */
"LC0_NO_PARAMS: Nie podano parametrow przetwarzania",
						/* LC0_OVERRUN	       -27 */
"LC0_OVERRUN: Blad OVERRUN",
						/* LC0_NO_DMA	       -28 */
"LC0_NO_DMA: Urzadzenie nie jest podlaczone do DMA",
						/* LC0_NO_IRQ	       -29 */
"LC0_NO_IRQ: Z modulem nie jest zwiazane zadne przerwanie",
						/* LC0_NOT_FULLY_SUP   -30 */
"LC0_NOT_FULLY_SUP: Funkcja w opracowaniu",
						/* LC0_NO_EXTMEM       -31 */
"LC0_NO_EXTMEM: Brak pamieci dodatkowej",
						/* LC0_NO_SEC_FREQ     -32 */
"LC0_NO_SEC_FREQ: Modul ma tylko jedna czestotliwosc",
						/* LC0_INTR_INST       -33 */
"LC0_INTR_INST: Procedura obslugi przerwania juz zainstalowana",
						/* LC0_BAD_PER2	       -34 */
"LC0_BAD_PER2: Bledna wielokrotnosc okresu probkowania",
						/* LC0_BAD_MODE	       -35 */
"LC0_BAD_MODE: Bledny tryb pracy",
						/* LC0_BAD_EXTMEM      -36 */
"LC0_BAD_EXTMEM: Bledny adres bufora w pamieci rozszerzonej",
						/* LC0_NOT_PROGRAMMED  -37 */
"LC0_CTC_NOT_PROGRAMMED: Zapis licznika przy niezaprogramowanym trybie pracy",
						/* LC0_REJECTED	       -38 */
"LC0_REJECTED: Za duzo jednoczesnych odwolan do driver'a",
    };

				/* ------ teksty ostrzezen                */
char	*DriverWarnings[] =
    {
						/* LC0_NON_EX_MOD	1 */
"LC0_NON_EX_MOD: Zazadano inicjalizacji nieistniejacych modulow",
						/* LC0_OTHER_LEN	2 */
"LC0_OTHER_LEN: Przepisano mniej probek niz zazadano",
						/* LC0_PREMATURE_END	3 */
"LC0_PREMATURE_END: Zakonczenie operacji z powodu przepelnienia bufora",
						/* LC0_IN_PROGRESS      4 */
"LC0_IN_PROGRESS: Badana transmisja jeszcze trwa",
    };

				/* ------- teksty informacji dodatkowych  */
char	*DriverAdditionalErrors[] =
    {
						/* LC0_E_NO_MODULE	-1 */
"LC0_E_NO_MODULE: Nie ma takiego modulu",
						/* LC0_E_NONEX_DEV	-2 */
"LC0_E_NONEX_DEV: Nie istnieje urzadzenie o tym numerze",
						/* LC0_E_BAD_CHAN	-3 */
"LC0_E_BAD_CHAN: Numer nieistniejacego kanalu",
						/* LC0_E_BAD_TIME	-4 */
"LC0_E_BAD_TIME: Zly odcinek czasu",
						/* LC0_E_BAD_DATE	-5 */
"LC0_E_BAD_DATE: Zla specyfikacja daty",
						/* LC0_E_BAD_THRE	-6 */
"LC0_E_BAD_THRE: Bledny prog wyzwalania analogowego",
						/* LC0_E_BROKEN_WAIT	-7 */
"LC0_E_BROKEN_WAIT: Przerwanie w trakcie oczekiwania na warunek startu",
						/* LC0_E_BROKEN_RUN	-8 */
"LC0_E_BROKEN_RUN: Przerwanie w trakcie przetwarzania",
						/* LC0_E_BAD_LEN	-9 */
"LC0_E_BAD_LEN: Zadeklarowano za duzo probek do zmierzenia",
    };

/***************************************************************************/
/***************************************************************************/
void main(void)
{
	checkdrivers();		/* rozpoznanie zainstalowanego driver'a    */
	askdriver();		/* odpytanie driver'a o konfiguracje       */
	displayconfiguration();	/* wyswietlenie konfiguracji modulu i      */
				/* toru a/c                                */
	installbreak();		/* zainstalowanie procedury obslugi        */
				/* przerwania generowanego przez Ctrl-Break*/
	pressanykey();		/* oczekiwanie na operatora                */
	blocktransmission();	/* wykonanie transmisji blokowej +         */
				/* wyswietlenie zmierzonych wartosci       */
	failblocktransmission();/* wykonanie blednej transmisji blokowej   */
	interruptedbefore();	/* wykonanie transmisji blokowej przerwanej*/
				/* przez operatora przed startem           */
	interruptedafter();	/* wykonanie transmisji blokowej przerwanej*/
				/* przez operatora po starcie              */
	asynchronointerr();	/* wykonanie transmisji blokowej           */
				/* asynchronicznej bez przerwan            */
	asynchrointerr();	/* wykonanie transmisji blokowej           */
				/* asynchronicznej z przerwaniem           */
	singletransmission();	/* wykonanie pomiaru w trybie pojedynczym  */

	quit();			/* zakonczenie programu                    */
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Rozpoznanie, czy driver jest zainstalowany.                           */
/* Uwagi:                                                                  */
/*   Funkcja dodatkowo wyswietla komunikat o testowanym module.            */
/*   Jezeli driver nie jest zainstalowany to po wyswietleniu wlasciwego    */
/*   komunikatu program konczy prace.                                      */
/***************************************************************************/
void checkdrivers(void)
{
	clrscr();
	gotoxy(1, 1);
	if(driverinstalled("LC3016^^"))
	    printf("Test modulu LC-030-1612\n");
	else
	    {
	    printf("Driver nie jest zainstalowany!\n");
	    exit(1);
	    }
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Sprawdzenie obecnosci drivera.                                        */
/* Sposob:                                                                 */
/*   Przez probe otwarcia urzadzenia o nazwie okreslonej przez driver.     */
/* Parametry:                                                              */
/*   name - nazwa urzadzenia                                               */
/* Wartosc:                                                                */
/*   TRUE  - driver jest zainstalowany                                     */
/*   FALSE - driver nie jest zainstalowany                                 */
/***************************************************************************/
int driverinstalled(char *name)
{
	int	hd;

	hd = open(name, 0);
	if(hd == -1)
	    return(FALSE);
	else
	    {
	    close(hd);
	    return(TRUE);
	    }
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Rozpoznanie konfiguracji badanego modulu.                             */
/* Sposob:                                                                 */
/*   Przez wykorzystanie funkcji driver'a GET_TOTAL_CONFIGURATION,         */
/*   GET_MODULE_CONFIGURATION, GET_INFO.                                   */
/* Uwagi:                                                                  */
/*   Funkcja wypelnia struktury total, module, info i inicjalizuje modul.  */
/***************************************************************************/
void askdriver(void)
{
	r.x.dx = FP_SEG(&s_total);
	r.x.di = FP_OFF(&s_total);
	int86(LCinterrupt, &r, &r);		/* GET_TOTAL_CONFIGURATION */

						/* inicjalizacja modulu    */
	s_init.LC0_IMODULE = s_total.LC0_TONF & 0xF;
	r.x.dx = FP_SEG(&s_init);
	r.x.di = FP_OFF(&s_init);
	int86(LCinterrupt, &r, &r);			/* MODULE_INIT     */

					/* spytanie o konfiguracje modulu  */
	s_module.LC0_MMODULE = LC0_MODA;
	r.x.dx = FP_SEG(&s_module);
	r.x.di = FP_OFF(&s_module);
	int86(LCinterrupt, &r, &r);		/* GET_MODULE_CONFIGURATION*/

					/* spytanie o konfiguracje toru a/c*/
	s_info.LC0_GMODULE = LC0_MODA;
	s_info.LC0_GTYPE   = LC0_AINPUT;
	s_info.LC0_GNUM    = 1;
	r.x.dx = FP_SEG(&s_info);
	r.x.di = FP_OFF(&s_info);
	int86(LCinterrupt, &r, &r);			/* GET_INFO        */
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wyswietlenie konfiguracji badanego modulu i jego toru a/c.            */
/* Sposob:                                                                 */
/*   Przez wykorzystanie informacji zawartych w strukturach module i info. */
/***************************************************************************/
void displayconfiguration(void)
{
	int	i;
					/* konfiguracja modulu             */
	printf("\n---------- Konfiguracja modulu:\n\n");
	printf("Adresy modulu: %04X, %04X (hex)\n",
				s_module.LC0_MBASE1, s_module.LC0_MBASE2);
	printf("Liczba przetwornikow a/c: %d\n", s_module.LC0_MIAD);
	printf("Liczba przetwornikow c/a: %d\n", s_module.LC0_MIDA);
	printf("Liczba portow cyfrowych wejsciowych: %d\n",
		s_module.LC0_MIDI);
	printf("Liczba portow cyfrowych wyjsciowych: %d\n",
		s_module.LC0_MIDO);
	printf("Czestotliwosc zegara modulu: %d MHz\n",
						s_module.LC0_MCLOCK / 1000);

					/* konfiguracja toru a/c           */
	printf("\n---------- Konfiguracja toru a/c:\n\n");
	printf("Liczba kanalow: %d\n", s_info.LC0_GCHAN);
	printf("Rozdzielczosc: %d bitow\n", s_info.LC0_GRES);
	printf("Zakres napiec: %.1f..%.1f V\n",
		(float)s_info.LC0_GMINV / 10,
		(float)s_info.LC0_GMAXV / 10);
	if(s_info.LC0_GDMA == 0xFF)
	    printf("Tor a/c nie jest podlaczony do kanalow DMA\n");
	else
	    printf("Numer kanalu DMA podlaczonego do toru a/c: %d\n",
							    s_info.LC0_GDMA);
	printf("Minimalne okresy probkowania [s]:\n");
	printf("     ");
	for(i = 0; i < s_info.LC0_GCHAN; i++)
	    {
	    printf("%.1f", (float)s_info.LC0_GMINP[i] / 10);
	    if(i < s_info.LC0_GCHAN - 1)
		{
	    	printf(", ");
		if((i + 1) % 8 == 0)
		    {
		    printf("\n");	/* zlamanie linii co 8 wielkosci   */
		    printf("     ");
		    }
		}
	    }
	printf("\n");
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Zainstalowanie procedury obslugi przerwania generowanego przez        */
/*   Ctrl-Break.                                                           */
/* Sposob:                                                                 */
/*   Przez wywolanie funkcji BREAK.                                        */
/***************************************************************************/
void installbreak(void)
{
	s_break.LC0_BMODE = LC0_BREAK_INST;
	s_break.LC0_BPROC = NULL;		/* podlozona zostanie      */
						/*   procedura driver'a    */
	r.x.dx = FP_SEG(&s_break);
	r.x.di = FP_OFF(&s_break);
	int86(LCinterrupt, &r, &r);			/* BREAK           */
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Przerwa miedzy kolejnymi czesciami programu - oczekiwanie na reakcje  */
/*   operatora.                                                            */
/***************************************************************************/
void pressanykey(void)
{
	printf("\nNacisnij dowolny klawisz . . .");
	getch();
	clrscr();
	gotoxy(1, 1);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie poprawnej transmisji blokowej i wyswietlenie zmierzonych    */
/*   wartosci.                                                             */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji transmission.                                 */
/***************************************************************************/
void blocktransmission(void)
{
	printf("---------- Poprawne przetwarzanie blokowe\n\n");
	s_analog_in.LC0_APER = (long)s_info.LC0_GMINP[CHANNELS - 1];
	transmission(LC0_SIMMED, FALSE, FALSE);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie blednej transmisji blokowej.                                */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT z okresem probkowania mniejszym  */
/*   niz minimalny wskazany przez driver.                                  */
/***************************************************************************/
void failblocktransmission(void)
{
	printf("---------- Bledne przetwarzanie blokowe\n\n");
	s_analog_in.LC0_APER = (long)s_info.LC0_GMINP[CHANNELS - 1] - 1;
	transmission(LC0_SIMMED, FALSE, FALSE);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie poprawnej transmisji blokowej ale przerwanej przez operatora*/
/*   (Ctrl-Break) w trakcie czekania na spelnienie warunku startu.         */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT z warunkiem startu LC0_STIME     */
/*   (start po okreslonym czasie) i parametrem tego warunku - 1000s.       */
/***************************************************************************/
void interruptedbefore(void)
{
	printf("---------- Przetwarzanie blokowe z oczekiwaniem 1000s\n");
	printf("---------- Oczekiwanie nalezy przerwac Ctrl-Break\n\n");
	s_analog_in.LC0_APER = (long)s_info.LC0_GMINP[CHANNELS - 1];
	s_analog_in.LC0_ASTART.time = 1000;
	transmission(LC0_STIME, FALSE, FALSE);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie poprawnej transmisji blokowej ale przerwanej przez operatora*/
/*   (Ctrl-Break) w trakcie pomiaru.                                       */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT z okresem probkowania 100s.      */
/***************************************************************************/
void interruptedafter(void)
{
	printf("---------- Przetwarzanie blokowe "
	       "z okresem probkowania 100s\n");
	printf("---------- Pomiar nalezy przerwac Ctrl-Break\n\n");
	s_analog_in.LC0_APER = 1000000000;
	transmission(LC0_SIMMED, FALSE, FALSE);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*    Wykonanie transmisji blokowej asynchronicznej bez przerwan.          */
/***************************************************************************/
void asynchronointerr(void)
{
	printf("---------- Przetwarzanie blokowe "
	       "asynchroniczne bez przerwan\n\n");
	s_analog_in.LC0_APER = (long)s_info.LC0_GMINP[CHANNELS - 1];
	s_analog_in.LC0_APER = 1000000;
	transmission(LC0_SIMMED, TRUE, FALSE);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*    Wykonanie transmisji blokowej asynchronicznej z przerwaniami.        */
/***************************************************************************/
void asynchrointerr(void)
{
	printf("---------- Przetwarzanie blokowe "
	       "asynchroniczne z przerwaniami\n\n");
	s_analog_in.LC0_APER = 1000000;
	s_analog_in.LC0_ASTART.time = 2;
	transmission(LC0_SIMMED, TRUE, TRUE);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie pomiaru bloku probek za pomoca tranmsisji pojedynczej, przy */
/*   czym caly blok ma byc zmierzony po 10s od startu.                     */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT.                                 */
/* Parametry:                                                              */
/* Wartosc:                                                                */
/* Uwagi:                                                                  */
/***************************************************************************/
void singletransmission(void)
{
	int	buf[BUFLEN];		/* bufor na probki                 */
	int	i = 0;

	printf("---------- Przetwarzanie pojedyncze - po 5 sekundach\n\n");
	s_analog_in.LC0_AMODULE = LC0_MODA;
	s_analog_in.LC0_ANUM = 1;
	s_analog_in.LC0_AMODE = LC0_MOD_START | 
				LC0_MOD_NEW_PAR |
				LC0_MOD_SINGLE;
				/* praca wielokanalowa, CHANNELS kanalow   */
	s_analog_in.LC0_ACHAN = CHANNELS;
	s_analog_in.LC0_AADDR = (int far *)buf; /* konieczna konwersja na  */
						/*   daleki adres          */
	s_analog_in.LC0_ALEN = CHANNELS;	/* dlugosc bufora (tylko   */
						/*   na jeden pomiar)      */
	s_analog_in.LC0_ASTST = LC0_STIME;
	s_analog_in.LC0_ASTART.time = 5;	/* start po 5 sekundach    */
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	s_analog_in.LC0_ASTST = LC0_SIMMED;	/* nastepne probki maja byc*/
						/* pobierane z maksymalna  */
						/* szybkoscia              */
	i = 1;
	s_analog_in.LC0_AADDR = (int far *)&buf[i * CHANNELS];
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	s_analog_in.LC0_AMODE &= ~LC0_MOD_NEW_PAR;	/* zgaszenie bitu  */
					    /* LC0_MOD_NEW_PAR (zeby driver*/
					    /* niepotrzebnie nie analizowal*/
					    /* parametrow)                 */
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	for(i = 2; i < SAMPLES; i++)
	    {
	    s_analog_in.LC0_AADDR = (int far *)&buf[i * CHANNELS];
	    int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	    }
	displaybuf(buf, CHANNELS, SAMPLES);
	pressanykey();
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wykonanie transmisji blokowej.                                        */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji ANALOG_INPUT.                                 */
/* Parametry:                                                              */
/*   start    - typ warunku startu                                         */
/*   asynchro - TRUE  - praca asynchroniczna                               */
/*              FALSE - praca synchroniczna                                */
/*   interr   - TRUE  - praca z przerwaniami                               */
/*              FALSE - praca bez przerwan                                 */
/*              parametr istotny tylko przy pracy asynchronicznej          */
/* Uwagi:                                                                  */
/*   Funkcja wywolujaca musi ustawic w strukturze s_analog_in okres        */
/*   probkowania i parametry warunku startu.                               */
/***************************************************************************/
void transmission(unsigned char start, int asynchro, int interr)
{
	int	buf[BUFLEN];		/* bufor na probki                 */

	printf("Pomiar blokowy, %d kanalow, %d probek, ", CHANNELS, SAMPLES);
	if(s_analog_in.LC0_APER < 10000)
	    printf("okres probkowania %g s:\n",
		    (float)s_analog_in.LC0_APER / 10);
	else if(s_analog_in.LC0_APER < 10000000)
	    printf("okres probkowania %g ms:\n",
		    (float)s_analog_in.LC0_APER / 10000);
	else
	    printf("okres probkowania %g s:\n",
		    (float)s_analog_in.LC0_APER / 10000000);
	switch(start)
	    {
	    case LC0_SIMMED:
	    	printf("Warunek startu: natychmiast\n");
		break;
	    case LC0_STIME:
	    	printf("Warunek startu: uplyw %lu sekund\n",
						s_analog_in.LC0_ASTART.time);
		printf("Oczekiwanie - \n");
		break;
	    			/* pozostale warunki nie sa obslugiwane bo */
				/*   w programie nie sa wykorzystywane     */
	    }
	s_analog_in.LC0_AMODULE = LC0_MODA;
	s_analog_in.LC0_ANUM = 1;
	s_analog_in.LC0_AMODE =
			LC0_MOD_START | 	/* zezwolenie na pomiar    */
		        LC0_MOD_NEW_PAR |	/* nowe parametry          */
		        LC0_MOD_BLOCK;		/* praca blokowa           */
	if(!asynchro)
	    {
	    s_analog_in.LC0_AMODE |= LC0_MOD_SYNCHR; /* praca synchroniczna*/
	    interr = FALSE;
	    }
	if(interr)
	    s_analog_in.LC0_AMODE |= LC0_MOD_INTR; /* praca z przerwaniami */

			/* stop po zmierzeniu okreslonej liczby probek     */
	s_analog_in.LC0_ASTST = start + LC0_ZSAMPLES;
				/* praca wielokanalowa, CHANNELS kanalow   */
	s_analog_in.LC0_ACHAN = CHANNELS;
	s_analog_in.LC0_ACHAN2 = 0;	/* praca z 1 czestotliwoscia       */
	s_analog_in.LC0_AADDR = (int far *)buf;	/* konieczna konwersja na  */
						/*   daleki adres          */
	s_analog_in.LC0_ALEN = BUFLEN;	/* dlugosc bufora                  */
	s_analog_in.LC0_ABMAR = 0;
	s_analog_in.LC0_AEMAR = 0;	/* oba marginesy zerowe            */
					/* calkowita liczba probek         */
	s_analog_in.LC0_ASTOP.samples = SAMPLES * CHANNELS;

	if(asynchro && interr)	/* przygotowanie pracy z przerwaniami      */
	    {
	    s_interr.LC0_SMODULE = 1;
	    s_interr.LC0_SPROC = mod_interrupt_service;
	    sstat = 0;
	    s_interr.LC0_SSTAT = &sstat;
	    r.x.dx = FP_SEG(&s_interr);
	    r.x.di = FP_OFF(&s_interr);
	    int86(LCinterrupt, &r, &r);		/* INTERRUPT_SERVICE       */
	    if(s_interr.LC0_STATUS != LC0_OK)
	    	{
		drivererror(s_interr.LC0_STATUS, s_interr.LC0_ERR_STAT);
		pressanykey();
		return;
		}
	    interruptflag = FALSE;
	    }
	r.x.dx = FP_SEG(&s_analog_in);
	r.x.di = FP_OFF(&s_analog_in);
	int86(LCinterrupt, &r, &r);			/* ANALOG_INPUT    */
	if(s_analog_in.LC0_STATUS != LC0_OK)
	    goto drv_error;
ok:
	if(!asynchro)				/* praca synchroniczna     */
	    goto display;
	else if(interr)		/* praca asynchroniczna z przerwaniami     */
	    {	/* tu czekanie na flage */
	    while((sstat & LC0_IS_BROKEN) == 0 && !interruptflag)
	    	;
	    if(sstat & LC0_IS_BROKEN)
	    	return;
	    else
	    	goto display;
	    }
	else			/* praca asynchroniczna bez przerwan       */
	    {
	    s_wait.LC0_WTYPE = LC0_AINPUT;
	    s_wait.LC0_WMODULE = 1;
	    s_wait.LC0_WNUM = 1;
	    s_wait.LC0_WMODE = LC0_W_TEST;
	    r.x.dx = FP_SEG(&s_wait);
	    r.x.di = FP_OFF(&s_wait);
						/* czekanie na koniec      */
	    do
		int86(LCinterrupt, &r, &r);		/* WAIT_FOR_END    */
	    while(s_wait.LC0_STATUS == LC0_IN_PROGRESS);
	    if(s_wait.LC0_STATUS == LC0_OK)		/* koniec poprawny */
	    	goto display;
	    else				/* koniec Ctrl-Break       */
		{
		drivererror(s_wait.LC0_STATUS, s_wait.LC0_ERR_STAT);
		pressanykey();
		}
	    }
	return;

drv_error:
	if(s_analog_in.LC0_STATUS == LC0_OTHER_LEN)
	    goto ok;
	else
	    {
	    drivererror(s_analog_in.LC0_STATUS, s_analog_in.LC0_ERR_STAT);
	    pressanykey();
	    }
	return;

display:
	if(transmit_data(buf, (long)BUFLEN, 1L, (long)SAMPLES, CHANNELS,
			 0, 1))
	    displaybuf(buf, CHANNELS, SAMPLES);
	pressanykey();
}

/****************************************************************************/
/* Przeznaczenie:                                                           */
/*   Obsluga przerwania przychodzacego z modulu po zakonczeniu przetwarzania*/
/* Sposob:                                                                  */
/*   Badanie stanu zmiennej komunikacyjnej sstat. Po zakonczeniu transmisji */
/*   wyinstalowanie procedury obslugi przerwania i powiadomienie drivera o  */
/*   zakonczeniu pomiaru.                                                   */
/* Uwagi:                                                                   */
/*   Driver przydziela procedurze stos o dlugosci 128 bajtow. Jezeli jest   */
/*   za malo to procedura powinna przelaczac sie na wlasny stos.            */
/*   Niezaleznie od tego wymagane jest wylaczenie dla tej procedury badania */
/*   stosu (dla Turbo C Borlanda jest to opcja kompilacji -N-).             */
/****************************************************************************/
void mod_interrupt_service(void)
{
	static	union	REGS	rr;
	static	char	*beg = "Poczatek - \n\r";
	static	char	*end = "Koniec\n\r";
	int	i;

	if(sstat & LC0_IS_START)
	    for(i = 0; beg[i] != '\0'; i++)
		putch(beg[i]);
	else if(sstat & LC0_IS_END_ADC)
	    {
				    /* wyinstalowanie obslugi przerwania   */
	    s_interr.LC0_SMODULE = 1;
	    s_interr.LC0_SPROC = NULL;
	    rr.x.dx = FP_SEG(&s_interr);
	    rr.x.di = FP_OFF(&s_interr);
	    int86(LCinterrupt, &rr, &rr);	/* INTERRUPT_SERVICE       */

			    /* powiadomienie driver'a o koncu prztwarzania */
	    s_wait.LC0_WTYPE = LC0_AINPUT;
	    s_wait.LC0_WMODULE = 1;
	    s_wait.LC0_WNUM = 1;
	    s_wait.LC0_WMODE = LC0_W_FINISHED;
	    rr.x.dx = FP_SEG(&s_wait);
	    rr.x.di = FP_OFF(&s_wait);
	    int86(LCinterrupt, &rr, &rr);		/* WAIT_FOR_END     */

	    interruptflag = TRUE;
	    for(i = 0; end[i] != '\0'; i++)
		putch(end[i]);
	    }
}

/****************************************************************************/
/* Przeznaczenie:                                                           */
/*   Odwrocenie kolejnosci kanalow tak, aby kanal 0 byl w kolumnie 0 itd.   */
/* Parametry:                                                               */
/*   buf  - bufor danych                                                    */
/*   len  - liczba probek w buforze                                         */
/*   chn1 - liczba kanalow podstawowych                                     */
/*   chn2 - liczba kanalow dodatkowych                                      */
/*   per2 - krotnosc okresu podstawowego                                    */
/* Uwagi:                                                                   */
/*   Poniewaz buf zostal wypelniony przez funkcje driver'a DATA_TRANSMIT to:*/
/*   len = ((per2 - 1) * chn1) + (chn1 + chn2)                              */
/****************************************************************************/
void reverse_data(int huge *buf, long len, int chn1, int chn2, int per2)
{
	long	lines,
		lj;
	int	i,
		j,
		n,
		v;
	int far	*b;

	if(chn1 == 1 && chn2 == 0)
	    return;
	if(chn2 == 0)
	    lines = len / chn1;		/* praca z jedna czestotliwoscia   */
	else
	    {				/* praca z dwiema czestotliwosciami */
	    lj = chn1 * per2 + chn2;
	    lines = (len / lj) * per2;
	    lines += (len % lj) / chn1;
	    }

	for(lj = 0; lj < lines; lj++)
	    {
	    if(chn2 == 0)
	    	i = chn1;
	    else
		i = ((lj + 1) % per2 == 0 ? chn2 + chn1 : chn1);
	    b = (int far *)buf;
	    n = i / 2;
	    for(j = 0; j < n; j++)
	    	{
		v = b[j];
		b[j] = b[i - j - 1];
		b[i - j - 1] = v;
		}
	    buf += i;
	    }
}

/****************************************************************************/
/* Przeznaczenie:                                                           */
/*   Przepisanie do bufora danych z pamieci modulu (LC-030).                */
/* Sposob:                                                                  */
/* Parametry:                                                               */
/*   buf     - bufor danych                                                 */
/*   buflen  - dlugosc bufora                                               */
/*   first   - numer pierwszej probki (w kanale podstawowym, liczonej od 1) */
/*          do przepisania                                                  */
/*   samples - liczba probek (w kanale podstawowym) do przepisania          */
/*   chn1    - liczba kanalow podstawowych                                  */
/*   chn2    - liczba kanalow dodatkowych                                   */
/*   per2    - krotnosc okresu podstawowego                                 */
/****************************************************************************/
int transmit_data(int huge *buf, long buflen, long first, long samples,
		  int chn1, int chn2, int per2)
{
	long	num,	/* bezwzgledny numer pierwszej probki do przepisania */
		len;	/* bezwzgledna liczba probek do przepisania          */
	union	REGS	r;

	if(chn2 == 0)
	    {
	    num = (first - 1) * chn1;
	    len = samples * chn1;
	    }
	else
	    {
	    num = ((first - 1) / per2) * (chn1 * per2 + chn2);
	    len = (samples / per2) * (chn1 * per2 + chn2);
	    len += (samples % per2) * chn1;
	    }

	s_data_trans.LC0_RMODE = LC0_FROM_EXT_DIR;
	s_data_trans.LC0_RADDR = (int far *)buf;
	s_data_trans.LC0_RLEN = buflen;
	s_data_trans.LC0_RMEAS = num + 1;
	s_data_trans.LC0_RNUM = len;
	r.x.dx = FP_SEG(&s_data_trans);
	r.x.di = FP_OFF(&s_data_trans);
	int86(LCinterrupt, &r, &r);			/* DATA_TRANSMIT   */
	if(s_data_trans.LC0_STATUS != LC0_OK &&
	   s_data_trans.LC0_STATUS != LC0_OTHER_LEN)
	    goto drv_error;
	reverse_data(buf, s_data_trans.LC0_RRNUM, chn1, chn2, per2);
	return(TRUE);

drv_error:
	drivererror(s_data_trans.LC0_STATUS, s_data_trans.LC0_ERR_STAT);
	return(FALSE);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wyswietlenie bufora z danymi pomiarowymi.                             */
/* Parametry:                                                              */
/*   buf - adres bufora                                                    */
/*   c   - liczba kanalow                                                  */
/*   s   - liczba probek na kanal                                          */
/***************************************************************************/
void displaybuf(int *buf, int c, int s)
{
	int	i,
		j;

	for(i = 0; i < s; i++)
	    {
	    printf("%2d: ", i + 1);
	    for(j = 0; j < c; j++)
		printf("%04X  ", buf[i * c + j]);
	    printf("\n");
	    }
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Wypisanie komunikatow o bledzie / ostrzezeniu / dodatkowej informacji */
/*   bledzie.                                                              */
/* Parametry:                                                              */
/*   status   - LC0_STATUS                                                 */
/*   err_stat - LC0_ERR_STAT                                               */
/***************************************************************************/
void drivererror(char status, char err_stat)
{
	if(status > 0)
	    printf("--------- Ostrzezenie:\n%s\n",
	    	   DriverWarnings[status - 1]);
	else
	    printf("--------- Blad:\n%s\n", DriverErrors[-status - 1]);
	if(err_stat < 0)
	    printf("--------- Informacje dodatkowe:\n%s\n",
	    	   DriverAdditionalErrors[-err_stat - 1]);
}

/***************************************************************************/
/* Przeznaczenie:                                                          */
/*   Zakonczenie pracy programu.                                           */
/* Sposob:                                                                 */
/*   Przez wykonanie funkcji exit. Wczesniej - rozstanie sie z driver'em za*/
/*   pomoca funkcji LEAVE_DRIVER.                                          */
/***************************************************************************/
void quit(void)
{
	r.x.dx = FP_SEG(&s_leave);
	r.x.di = FP_OFF(&s_leave);
	int86(LCinterrupt, &r, &r);			/* LEAVE_DRIVER    */

	printf("Dziekuje, to wszystko!\n");
	exit(0);
}
